package cn.teammodel.controller.admin.service.impl;

import cn.teammodel.common.PK;
import cn.teammodel.controller.admin.service.ArtService;
import cn.teammodel.model.dto.admin.art.ArtFindDto;
import cn.teammodel.model.entity.school.ClassInfo;
import cn.teammodel.model.vo.admin.ArtElementsVo;
import cn.teammodel.repository.ArtRepository;
import cn.teammodel.repository.ClassRepository;
import cn.teammodel.repository.StudentRepository;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Collectors;

@Service
public class ArtServiceImpl implements ArtService {
    @Resource
    private ArtRepository artRepository;
    @Resource
    private ClassRepository classRepository;
    @Resource
    private StudentRepository studentRepository;
    @Override
    public List<ArtElementsVo> getArtList(ArtFindDto artFindDto) {
        List<ArtElementsVo> artElementsVos = artRepository.findPeriodById(artFindDto.getPeriodId(),"Art-"+ artFindDto.getCode());
        List<String> classIds = artElementsVos.stream()
                .map(ArtElementsVo::getClasses) // 正确的方法引用
                .flatMap(List::stream) // 将内部列表扁平化
                .collect(Collectors.toList());

        List<ClassInfo> classes = classRepository.findAllByCodeAndIdIn("Class-"+artFindDto.getCode(),classIds);
        try {
            for (ArtElementsVo artElementsVo : artElementsVos) {
                List<String> classes1 = artElementsVo.getClasses();
                int stuInClassCount = 0;
                for(String classId : classes1) {
                    stuInClassCount += studentRepository.countByClassIdAndCode(classId, String.format(PK.STUDENT, artFindDto.getCode()));
                    ArtElementsVo.ClassInfos classInfos = new ArtElementsVo.ClassInfos();
                    Optional<String> className =  classes.stream()
                            .filter(classInfo -> classInfo.getId().equals(classId))
                            .map(ClassInfo::getName)
                            .findFirst();
                    classInfos.setId(classId);
                    classInfos.setName(className.orElse("No Class Name"));
                    artElementsVo.addClassesInfos(classInfos);
                }
                artElementsVo.setCount(stuInClassCount);

            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        return artElementsVos;
    }
}
